<?php
/* =====================================================================
 * Dieses Skript ist Teil von "Wetter-Analyse in Dekaden (WADE)"
 * Von "Trixi aus Witten/NRW" - http://taw-wade.kilu.de/
 *                 Version 17.07.01 - Build 23.07.2017
 * Lizenziert unter "Namensnennung-Weitergabe unter gleichen Bedingungen
 * 3.0 Deutschland (CC BY-SA 3.0)"
 *                 ==> http://creativecommons.org/licenses/by-sa/3.0/de/
 *
 * Diese Software ist FREIE SOFTWARE und wird mit der Hoffnung, daß sie
 * nützlich sein könnte, zur Verfügung gestellt, jedoch OHNE JEDE
 * GEWÄHRLEISTUNG. Auch nicht für eine ALLGEMEINE GEBRAUCHSTAUGLICHKEIT
 * oder Stabilität für die NUTZUNG ZU EINEM BESTIMMTEN ZWECK. Die freie
 * Software, von der hier die Rede sein soll, ist kein "Freibier",
 * sondern sie gibt dir die Freiheiten
 *
 *   o  die Software für einen beliebigen Zweck auszuführen
 *   o  die Funktionsweise der Software zu studieren und sie an deine
 *      eigenen Bedürfnisse anzupassen
 *   o  Kopien der Software weiterzugeben
 *   o  sowie die Software zu verbessern und diese Verbesserungen zu
 *      veröffentlichen.
*/
// @module rekorde "\t\tBerechnet für jede Dekade die Dekadenrekorde und\n\t\t\tabsolute einzelner Tage\n"
$DA->KonsolenAusgabe('Beginne mit der Ausführung von '.basename(__FILE__),1);
	if ( !is_dir($einstellungen['zwischenspeicher']['speicher_pfad']) )
	$DA->KonsolenAusgabe('Das Verzeichnis für den Zwischenspeicher existiert nicht',-1);
	if ( strlen($DA->cli_parameter['station']) < 4 )
	$DA->KonsolenAusgabe('Es wurde keine Station mit "--station=[name]" angegeben',-1);
	if ( !isset($einstellungen['daten'][$DA->cli_parameter['station']]) )
	$DA->KonsolenAusgabe('Diese Station befindet sich nicht in der Konfiguration',-1);
	if ( $DA->cli_parameter['vergleich'] === '' )
	$DA->KonsolenAusgabe('Es wurde kein Vergleichszeitraum mit "--vergleich=[jahre]" angegeben',-1);

	function WADE_MarkiereZelle($daten){
	global $einstellungen,$jahre_markieren;
		if ( $einstellungen['rekorde']['hervorheben_in_html'] && isset($daten[2]) && $daten[2] )
		return 'class="hervorheben"';
		elseif ( is_array($jahre_markieren) && isset($daten[3]) && $daten[3] )
		return 'class="markieren"';
		else
		return '';
	}

$DA->KonsolenAusgabe('Erstelle Grundgerüst für Rekordwerte-Ermittlung',2);
$datensatz = $DA->HoleRoheDatenDerJahre($DA->cli_parameter['station'],$DA->cli_parameter['vergleich']);
$daten_temp = array();
$rekorde = array();

	foreach ( $DA->grundgeruest_dekaden as $dekade=>$werte ){
	$rekorde[$dekade] = array();
		foreach ( $einstellungen['rekorde']['datenreihen_auswerten'] as $schluessel ){
		$typ = 1;
			switch ( $typ ){
			case 1:
			$max = -99;
			$min = 99;
			break;
			}
		$rekorde[$dekade][$schluessel] = array(
		'alle'=>array('max'=>array($max,''),'min'=>array($min,'')),
		'einzel'=>array('max'=>array($max,''),'min'=>array($min,''))
		);
		}
	}

$DA->KonsolenAusgabe('Suche nach Rekorden für eine gesamte Dekade',2);
$jahre_markieren = false;

	if ( strlen($einstellungen['rekorde']['jahre_markieren_in_html']) > 0 ){
	$jahre_markieren = $DA->JahresZeitraumErstellen($einstellungen['rekorde']['jahre_markieren_in_html']);
		if ( is_array($jahre_markieren) )
		$DA->KonsolenAusgabe('Die folgenden Jahre werden markiert '.implode(',',$jahre_markieren),2);
	}

	foreach ( $datensatz as $daten ){
	$dekade = $DA->ErmittleDekade($daten['tag']);
	$schluessel = $daten['monat'].'/'.$dekade;
		foreach ( $einstellungen['rekorde']['datenreihen_auswerten'] as $rschluessel ){
			if ( !isset($daten_temp[$schluessel][$rschluessel][$daten['jahr']]) )
			$daten_temp[$schluessel][$rschluessel][$daten['jahr']] = array();
		$daten_temp[$schluessel][$rschluessel][$daten['jahr']][] = $daten[$rschluessel];
		}
	}

	foreach ( $DA->grundgeruest_dekaden as $dekade=>$werte ){
		foreach ( $einstellungen['rekorde']['datenreihen_auswerten'] as $rschluessel ){
			foreach ( $daten_temp[$dekade][$rschluessel] as $jahr=>$daten ){
			$DA->UngueltigeDatensaetzeEntfernen($daten,sprintf('%04d,%s::%s',$jahr,$dekade,$rschluessel));
			$wert = round( array_sum($daten) / sizeof($daten), 1);
				if ( $wert > $rekorde[$dekade][$rschluessel]['alle']['max'][0] ){
				$rekorde[$dekade][$rschluessel]['alle']['max'][0] = $wert;
				$rekorde[$dekade][$rschluessel]['alle']['max'][1] = $jahr;
					if ( $jahr === (int)date('Y') )
					$rekorde[$dekade][$rschluessel]['alle']['max'][2] = true;
					if ( is_array($jahre_markieren) && in_array($jahr,$jahre_markieren,true) )
					$rekorde[$dekade][$rschluessel]['alle']['max'][3] = true;
				}
				if ( $wert < $rekorde[$dekade][$rschluessel]['alle']['min'][0] ){
				$rekorde[$dekade][$rschluessel]['alle']['min'][0] = $wert;
				$rekorde[$dekade][$rschluessel]['alle']['min'][1] = $jahr;
					if ( $jahr === (int)date('Y') )
					$rekorde[$dekade][$rschluessel]['alle']['min'][2] = true;
					if ( is_array($jahre_markieren) && in_array($jahr,$jahre_markieren,true) )
					$rekorde[$dekade][$rschluessel]['alle']['min'][3] = true;
				}
			}
		}
	}

$DA->KonsolenAusgabe('Suche nach Rekorden einzelner Tage einer gesamten Dekade',2);

	foreach  ( $datensatz as $daten ){
	$dekade = $DA->ErmittleDekade($daten['tag']);
	$schluessel = $daten['monat'].'/'.$dekade;
		foreach ( $einstellungen['rekorde']['datenreihen_auswerten'] as $rschluessel ){
			if ( $daten[$rschluessel] !== '---' && $daten[$rschluessel] > $rekorde[$schluessel][$rschluessel]['einzel']['max'][0] ){
			$rekorde[$schluessel][$rschluessel]['einzel']['max'][0] = $daten[$rschluessel];
			$rekorde[$schluessel][$rschluessel]['einzel']['max'][1] = sprintf('%02d.%02d.%04d',$daten['tag'],$daten['monat'],$daten['jahr']);
				if ( $daten['jahr'] === (int)date('Y') )
				$rekorde[$schluessel][$rschluessel]['einzel']['max'][2] = true;
			}
			if ( $daten[$rschluessel] !== '---' && $daten[$rschluessel] < $rekorde[$schluessel][$rschluessel]['einzel']['min'][0] ){
			$rekorde[$schluessel][$rschluessel]['einzel']['min'][0] = $daten[$rschluessel];
			$rekorde[$schluessel][$rschluessel]['einzel']['min'][1] = sprintf('%02d.%02d.%04d',$daten['tag'],$daten['monat'],$daten['jahr']);
				if ( $daten['jahr'] === (int)date('Y') )
				$rekorde[$schluessel][$rschluessel]['einzel']['min'][2] = true;
			}
		}
	}

$DA->KonsolenAusgabe('Datenbearbeitung beendet',1);
$DA->KonsolenAusgabe('Erstellen des Reports vom Typ '.$DA->cli_parameter['typ'],1);
$DA->KonsolenAusgabe('Die Dekaden folgender Monate wurden ausgewählt '.$einstellungen['rekorde']['monate_anzeigen'],1);
$monate_anzeigen = explode(',',$einstellungen['rekorde']['monate_anzeigen']);
define('LF',"\r\n"); // \r\n für bessere Lesbarkeit unter Windows beim Standardeditor
$report = '';

	switch ( $DA->cli_parameter['typ'] ){
	case 'text':
	$report .= str_repeat('=',72).LF;
	$report .= 'DEKADEN-REKORDE IM ZEITRAUM '.$DA->cli_parameter['vergleich'].LF;
	$report .= 'Erstellt am '.strftime(WADE_FDATE,time()).LF;
	$report .= 'Name der Station: '.$einstellungen['daten'][$DA->cli_parameter['station']]['name'].
		' ('.$einstellungen['daten'][$DA->cli_parameter['station']]['code'].')'.LF;
	$report .= 'Daten-Quelle: '.$einstellungen['daten'][$DA->cli_parameter['station']]['quelle'].LF.LF;
		if ( !empty($einstellungen['rekorde']['kommentar']) )
		$report .= $einstellungen['rekorde']['kommentar'].LF.LF;

		foreach ( $rekorde as $dekade=>$daten ){
		$dekade_string = $DA->DekadeNachLokalisiertesDatum($dekade,'%B');
		$monat = substr($dekade,0,strpos($dekade,'/'));
			if ( !in_array($monat,$monate_anzeigen) )
			continue;

		$report .= '#### '.str_replace(chr(10),' . ',$dekade_string).' ####'.LF.LF.chr(9);
			foreach ( $einstellungen['rekorde']['datenreihen_auswerten'] as $rschluessel )
			$report .= str_pad($rschluessel,20,' ',STR_PAD_RIGHT);

			if ( $einstellungen['rekorde']['maximum_rekorde_anzeigen'] ){
			$report .= LF.'MAX'.chr(9);
				if ( $einstellungen['rekorde']['dekaden_rekorde_anzeigen'] ){
					foreach ( $einstellungen['rekorde']['datenreihen_auswerten'] as $rschluessel )
					$report .= str_pad(number_format($rekorde[$dekade][$rschluessel]['alle']['max'][0],1).' ('.$rekorde[$dekade][$rschluessel]['alle']['max'][1].')',20,' ',STR_PAD_RIGHT);
				}
			$report .= LF.chr(9);
				if ( $einstellungen['rekorde']['tages_rekorde_anzeigen'] ){
					foreach ( $einstellungen['rekorde']['datenreihen_auswerten'] as $rschluessel )
					$report .= str_pad(number_format($rekorde[$dekade][$rschluessel]['einzel']['max'][0],1).' ('.$rekorde[$dekade][$rschluessel]['einzel']['max'][1].')',20,' ',STR_PAD_RIGHT);
				}
			$report .= LF;
			}

			if ( $einstellungen['rekorde']['minimum_rekorde_anzeigen'] ){
			$report .= LF.'MIN'.chr(9);
				if ( $einstellungen['rekorde']['dekaden_rekorde_anzeigen'] ){
					foreach ( $einstellungen['rekorde']['datenreihen_auswerten'] as $rschluessel )
					$report .= str_pad(number_format($rekorde[$dekade][$rschluessel]['alle']['min'][0],1).' ('.$rekorde[$dekade][$rschluessel]['alle']['min'][1].')',20,' ',STR_PAD_RIGHT);
				}
			$report .= LF.chr(9);
				if ( $einstellungen['rekorde']['tages_rekorde_anzeigen'] ){
					foreach ( $einstellungen['rekorde']['datenreihen_auswerten'] as $rschluessel )
					$report .= str_pad(number_format($rekorde[$dekade][$rschluessel]['einzel']['min'][0],1).' ('.$rekorde[$dekade][$rschluessel]['einzel']['min'][1].')',20,' ',STR_PAD_RIGHT);
				}
			}

		$report .= LF.LF;
			if ( strlen($einstellungen['report']['lizenz_text']) > 20 )
			$report .= $einstellungen['report']['lizenz_text'];
			if ( strlen($einstellungen['report']['lizenz_uri']) > 8 )
			$report.= LF.$einstellungen['report']['lizenz_uri'].LF.LF;
		}
	break;

	case 'html':
	$report .= '<!DOCTYPE html>'.LF;
	$report .= '<html>'.LF;
	$report .= '<head>'.LF;
	$report .= '<meta http-equiv="content-type" content="text/html;charset=utf-8"></meta>'.LF;
	$report .= '<style type="text/css">.kopf { font-weight: bold; }
		.hervorheben { color: red; font-weight: bold; }
		.markieren { color: blue; }
		.hell { background-color: #ccc; } .dunkel { background-color: #aaa; }
		.hell:hover, .dunkel:hover { background-color: #ffa; }</style>'.LF;
	$report .= '</head>'.LF;
	$report .= '<body>'.LF;
	$report .= '<h1>DEKADEN-REKORDE IM ZEITRAUM '.htmlspecialchars($DA->cli_parameter['vergleich']).'</h1>'.LF;
	$report .= '<p>Erstellt am '.strftime(WADE_FDATE,time()).'<br />'.LF;
	$report .= 'Name der Station: '.htmlspecialchars($einstellungen['daten'][$DA->cli_parameter['station']]['name']).
		' ('.htmlspecialchars($einstellungen['daten'][$DA->cli_parameter['station']]['code']).')<br />'.LF;
	$report .= 'Daten-Quelle: '.htmlspecialchars($einstellungen['daten'][$DA->cli_parameter['station']]['quelle']).'</p>'.LF;
		if ( !empty($einstellungen['rekorde']['kommentar']) )
		$report .= '<p>'.$einstellungen['rekorde']['kommentar'].'</p>'.LF;

		foreach ( $rekorde as $dekade=>$daten ){
		$dekade_string = $DA->DekadeNachLokalisiertesDatum($dekade,'%B');
		$monat = substr($dekade,0,strpos($dekade,'/'));
			if ( !in_array($monat,$monate_anzeigen) )
			continue;

		$report .= '<h2>'.str_replace(chr(10),' . ',$dekade_string).'</h2>'.LF;
		$report .= '<table>'.LF;
		$report .= '<tr class="kopf"><td>&nbsp;</td>'.LF;
			foreach ( $einstellungen['rekorde']['datenreihen_auswerten'] as $rschluessel )
			$report .= '<td>'.$rschluessel.'</td>'.LF;
		$report .= '</tr>'.LF;

			if ( $einstellungen['rekorde']['maximum_rekorde_anzeigen'] ){
			$report .= '<tr class="hell"><td>MAX</td>'.LF;
				if ( $einstellungen['rekorde']['dekaden_rekorde_anzeigen'] ){
					foreach ( $einstellungen['rekorde']['datenreihen_auswerten'] as $rschluessel )
					$report .= '<td '.WADE_MarkiereZelle($rekorde[$dekade][$rschluessel]['alle']['max']).'>'.number_format($rekorde[$dekade][$rschluessel]['alle']['max'][0],1).' ('.$rekorde[$dekade][$rschluessel]['alle']['max'][1].')</td>'.LF;
				}
			$report .= '</tr><tr class="hell"><td>&nbsp;</td>'.LF;
				if ( $einstellungen['rekorde']['tages_rekorde_anzeigen'] ){
					foreach ( $einstellungen['rekorde']['datenreihen_auswerten'] as $rschluessel )
					$report .= '<td '.WADE_MarkiereZelle($rekorde[$dekade][$rschluessel]['einzel']['max']).'>'.number_format($rekorde[$dekade][$rschluessel]['einzel']['max'][0],1).' ('.$rekorde[$dekade][$rschluessel]['einzel']['max'][1].')</td>'.LF;
				}
			$report .= '</tr>'.LF;
			}

			if ( $einstellungen['rekorde']['minimum_rekorde_anzeigen'] ){
			$report .= '<tr class="dunkel"><td>MIN</td>'.LF;
				if ( $einstellungen['rekorde']['dekaden_rekorde_anzeigen'] ){
					foreach ( $einstellungen['rekorde']['datenreihen_auswerten'] as $rschluessel )
					$report .= '<td '.WADE_MarkiereZelle($rekorde[$dekade][$rschluessel]['alle']['min']).'>'.number_format($rekorde[$dekade][$rschluessel]['alle']['min'][0],1).' ('.$rekorde[$dekade][$rschluessel]['alle']['min'][1].')</td>'.LF;
				}
			$report .= '</tr><tr class="dunkel"><td>&nbsp;</td>'.LF;
				if ( $einstellungen['rekorde']['tages_rekorde_anzeigen'] ){
					foreach ( $einstellungen['rekorde']['datenreihen_auswerten'] as $rschluessel )
					$report .= '<td '.WADE_MarkiereZelle($rekorde[$dekade][$rschluessel]['einzel']['min']).'>'.number_format($rekorde[$dekade][$rschluessel]['einzel']['min'][0],1).' ('.$rekorde[$dekade][$rschluessel]['einzel']['min'][1].')</td>'.LF;
				}
			$report .= '</tr>'.LF;
			}

		$report .= '</table>'.LF;
		}
		if ( strlen($einstellungen['report']['lizenz_text']) > 20 ){
			if ( strlen($einstellungen['report']['lizenz_uri']) > 8 )
			$report .= '<a href="'.$einstellungen['report']['lizenz_uri'].'" target="_blank">'.htmlspecialchars($einstellungen['report']['lizenz_text']).'</a>'.LF;
			else
			$report .= htmlspecialchars($einstellungen['report']['lizenz_text']).LF;
		}
	$report .= '</body>'.LF;
	$report .= '</html>';
	break;

	case 'xml':
	$report .= '<?xml version="1.0" encoding="utf-8" standalone="yes"?>'.LF;
	$report .= '<rekorde>'.LF;
		if ( !empty($einstellungen['rekorde']['kommentar']) )
		$report .= '/* '.$einstellungen['rekorde']['kommentar'].' */'.LF;
	$report .= '<meta>'.LF;
	$report .= chr(9).'<erstelltam>'.strftime(WADE_FDATE,time()).'</erstelltam>'.LF;
	$report .= chr(9).'<zeitraum>'.htmlspecialchars($DA->cli_parameter['vergleich']).'</zeitraum>'.LF;
	$report .= chr(9).'<name>'.htmlspecialchars($einstellungen['daten'][$DA->cli_parameter['station']]['name']).'</name>'.LF;
	$report .= chr(9).'<code>'.htmlspecialchars($einstellungen['daten'][$DA->cli_parameter['station']]['code']).'</code>'.LF;
	$report .= chr(9).'<datenquelle>'.htmlspecialchars($einstellungen['daten'][$DA->cli_parameter['station']]['quelle']).'</datenquelle>'.LF;
	$report .= '</meta>'.LF;
	$report .= '<lizenz>'.LF;
	$report .= chr(9).'<name>'.htmlspecialchars($einstellungen['report']['lizenz_text']).'</name>'.LF;
	$report .= chr(9).'<uri>'.$einstellungen['report']['lizenz_uri'].'</uri>'.LF;
	$report .= '</lizenz>'.LF;
	$report .= '<daten>'.LF;

		foreach ( $rekorde as $dekade=>$daten ){
		$monat = substr($dekade,0,strpos($dekade,'/'));
			if ( !in_array($monat,$monate_anzeigen) )
			continue;
		$dekaden_daten = explode('/',$dekade);
		$report .= chr(9).'<datensatz>'.LF;
		$report .= chr(9).chr(9).'<dekade_'.str_replace('/','_'.$dekade).' id="'.$DA->StrZahlNachMonat($dekaden_daten[0]).'/'.$dekaden_daten[1].'" />'.LF;

			if ( $einstellungen['rekorde']['maximum_rekorde_anzeigen'] ){
			$report .= chr(9).chr(9).chr(9).'<werte_maximum>'.LF;
				if ( $einstellungen['rekorde']['dekaden_rekorde_anzeigen'] ){
					foreach ( $einstellungen['rekorde']['datenreihen_auswerten'] as $rschluessel ){
					$report .= chr(9).chr(9).chr(9).chr(9).'<volledekade>'.LF;
					$report .= chr(9).chr(9).chr(9).chr(9).chr(9).'<schluessel>'.$rschluessel.'</schluessel>'.LF;
					$report .= chr(9).chr(9).chr(9).chr(9).chr(9).'<wert>'.number_format($rekorde[$dekade][$rschluessel]['alle']['max'][0],1).'</wert>'.LF;
					$report .= chr(9).chr(9).chr(9).chr(9).chr(9).'<jahr>'.$rekorde[$dekade][$rschluessel]['alle']['max'][1].'</jahr>'.LF;
					$report .= chr(9).chr(9).chr(9).chr(9).'</volledekade>'.LF;
					}
				}
				if ( $einstellungen['rekorde']['tages_rekorde_anzeigen'] ){
					foreach ( $einstellungen['rekorde']['datenreihen_auswerten'] as $rschluessel ){
					$report .= chr(9).chr(9).chr(9).chr(9).'<einzeltag>'.LF;
					$report .= chr(9).chr(9).chr(9).chr(9).chr(9).'<schluessel>'.$rschluessel.'</schluessel>'.LF;
					$report .= chr(9).chr(9).chr(9).chr(9).chr(9).'<wert>'.number_format($rekorde[$dekade][$rschluessel]['einzel']['max'][0],1).'</wert>'.LF;
					$report .= chr(9).chr(9).chr(9).chr(9).chr(9).'<datum>'.$rekorde[$dekade][$rschluessel]['einzel']['max'][1].'</datum>'.LF;
					$report .= chr(9).chr(9).chr(9).chr(9).'</einzeltag>'.LF;
					}
				}
			$report .= chr(9).chr(9).chr(9).'</werte_maximum>'.LF;
			}

			if ( $einstellungen['rekorde']['minimum_rekorde_anzeigen'] ){
			$report .= chr(9).chr(9).chr(9).'<werte_minimum>'.LF;
				if ( $einstellungen['rekorde']['dekaden_rekorde_anzeigen'] ){
					foreach ( $einstellungen['rekorde']['datenreihen_auswerten'] as $rschluessel ){
					$report .= chr(9).chr(9).chr(9).chr(9).'<volledekade>'.LF;
					$report .= chr(9).chr(9).chr(9).chr(9).chr(9).'<schluessel>'.$rschluessel.'</schluessel>'.LF;
					$report .= chr(9).chr(9).chr(9).chr(9).chr(9).'<wert>'.number_format($rekorde[$dekade][$rschluessel]['alle']['min'][0],1).'</wert>'.LF;
					$report .= chr(9).chr(9).chr(9).chr(9).chr(9).'<jahr>'.$rekorde[$dekade][$rschluessel]['alle']['min'][1].'</jahr>'.LF;
					$report .= chr(9).chr(9).chr(9).chr(9).'</volledekade>'.LF;
					}
				}
				if ( $einstellungen['rekorde']['tages_rekorde_anzeigen'] ){
					foreach ( $einstellungen['rekorde']['datenreihen_auswerten'] as $rschluessel ){
					$report .= chr(9).chr(9).chr(9).chr(9).'<einzeltag>'.LF;
					$report .= chr(9).chr(9).chr(9).chr(9).chr(9).'<schluessel>'.$rschluessel.'</schluessel>'.LF;
					$report .= chr(9).chr(9).chr(9).chr(9).chr(9).'<wert>'.number_format($rekorde[$dekade][$rschluessel]['einzel']['min'][0],1).'</wert>'.LF;
					$report .= chr(9).chr(9).chr(9).chr(9).chr(9).'<datum>'.$rekorde[$dekade][$rschluessel]['einzel']['min'][1].'</datum>'.LF;
					$report .= chr(9).chr(9).chr(9).chr(9).'</einzeltag>'.LF;
					}
				}
			$report .= chr(9).chr(9).chr(9).'</werte_minimum>'.LF;
			}

		$report .= chr(9).'</datensatz>'.LF;
		}

	$report .= '</daten>'.LF;
	$report .= '</rekorde>';
	break;
	}

	if ( !empty($einstellungen['report']['ausgabe_datei_maske']) && is_writeable(dirname($einstellungen['report']['ausgabe_datei_maske'])) )
	file_put_contents($einstellungen['report']['ausgabe_datei_maske'],$report);
$DA->KonsolenAusgabe('Report erstellt in "'.$einstellungen['report']['ausgabe_datei_maske'].'"',1);
$DA->KonsolenAusgabe('Aufgaben erledigt. Ciao!',0);
?>
